module KartRace
  class Race
    prepend Services::Command

    attr_reader :race, :file, :result

    def initialize(file: nil, race: nil)
      @file = file
      @race = race
    end

    def call
      parse_race
      poleposition
    end

    def best_lap
      race.flat_map(&:laps).min_by(&:time)
    end

    def average_race_speed
    end

    def poleposition
      winner = race.find { |r| r.laps.map(&:number).max_by && r.laps.map(&:number).min }
      winner.racer
    end

    private

    def parse_race
      race = File.readlines(file)
        .map { |line| KartRace::Services::Assign.call(line) }
        .inject({}) do |hash, i|
          racer = i[:racer]
          hash[racer] ||= Array.new
          hash[racer] << Lap.new(time: i[:time],
                                 number: i[:lap_number],
                                 lap_time: i[:lap_time])
          hash
        end

      @race = race.map { |racer, laps| Aftermath.new(racer: racer, laps: laps) }.compact
    end
  end
end
