#frozen_string_literal: true
module KartRace
  module Services
    class Assign
      prepend KartRace::Services::Command

      RACERLINE = /^(\d{2}:\d{2}:\d{2}\.\d{3})\s+(\d{3}) – ([A-Z]\.[A-Z]+)\s+(\d+)\s+(\d+:\d+\.\d{3})\s+(\d+,\d+)/.freeze

      attr_reader :line

      def initialize(line)
        @line = line
      end

      def call
        return unless line.match(RACERLINE)
        {
          time: $1,
          lap_number: $4,
          lap_time: $5,
          average_speed: $6,
          racer: Racer.new(number: $2, name: $3)
        }
      end
    end
  end
end
