module KartRace
  module Services
    module Command

      attr_reader :result

      module ClassMethods
        def call(*args, &block)
          new(*args, &block).call
        end
      end

      def self.prepended(base)
        base.extend ClassMethods
      end

      def process
        fail NotImplementedError unless defined?(super)
        @result = super

        self
      end
    end
  end
end
